From 94e2c40913831de7870a46d90175db0388308691 Mon Sep 17 00:00:00 2001
From: James Coleman <jtc331@gmail.com>
Date: Sun, 19 Apr 2020 12:13:09 -0400
Subject: [PATCH v2 1/3] Disable mark/restore for incremental sort

---
 src/backend/executor/execAmi.c | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
index e2154ba86a..25760572d6 100644
--- a/src/backend/executor/execAmi.c
+++ b/src/backend/executor/execAmi.c
@@ -421,6 +421,14 @@ ExecSupportsMarkRestore(Path *pathnode)
 		case T_Sort:
 			return true;
 
+		case T_IncrementalSort:
+
+			/*
+			 * Unlike full sort, incremental sort keeps only a single group of
+			 * tuples in memory, so it can't mark and restore..
+			 */
+			return false;
+
 		case T_CustomScan:
 			{
 				CustomPath *customPath = castNode(CustomPath, pathnode);
-- 
2.17.1

